# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()	%{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without repolib

%define repodir %{_javadir}/repository.jboss.com/org/jboss/ejb3/jboss-ejb3-core/%{namedversion}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define section free
%global namedversion %{version}

Name:           jboss-ejb3-core
Version:        1.3.8
Release:        0.1%{?dist}
Epoch:          0
Summary:        JBoss EJB3 Core
License:        LGPLv2+
Group:          Development/Java
URL:            http://www.jboss.org/
# svn export http://anonsvn.jboss.org/repos/jbossas/projects/ejb3/tags/jboss-ejb3-core-1.3.8/ && tar cjf jboss-ejb3-core-1.3.8.tar.bz2 jboss-ejb3-core-1.3.8/
# Exported revision 112095.
Source0:        jboss-ejb3-core-%{version}.tar.bz2
Source1:        jboss-ejb3-core-jpp-depmap.xml
Source2:        jboss-ejb3-core-settings.xml
Source3:	jboss-ejb3-core-component-info.xml
Patch0:         jboss-ejb3-core-pom.patch
Patch1:         jboss-ejb3-core-server-config.patch
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       java >= 0:1.5.0
Requires:       jpackage-utils
Requires:       javassist >= 0:3.7.1
Requires:       hibernate3-annotations
Requires:       hibernate3
Requires:       hibernate3-entitymanager
Requires:       jboss-aop2
Requires:       jboss-remoting-aspects
Requires:       jboss-cache-core >= 0:3.1.0
Requires:       jboss-cluster-ha-client >= 0:1.1.1
Requires:       jboss-cluster-ha-server-api >= 0:1.1.1
Requires:       jboss-deployers
Requires:       jboss-ejb3-context-base >= 0:0.1.1
Requires:       jboss-ejb3-context-naming >= 0:0.1.1
Requires:       jboss-ejb3-cache >= 0:1.0.0
Requires:       jboss-ejb3-common >= 0:1.0.1
Requires:       jboss-ejb3-endpoint >= 0:0.1.0
# XXX: 1.1.1
Requires:       jboss-ejb3-ext-api >= 0:1.0.0
# XXX: 1.1.1
Requires:       jboss-ejb3-ext-api-impl >= 0:1.0.0
Requires:       jboss-ejb3-interceptors >= 0:1.0.6
Requires:       jboss-ejb3-jpa-int
Requires:       jboss-ejb3-metadata >= 0:1.0.0
Requires:       jboss-ejb3-proxy-clustered >= 0:1.0.3
# XXX: 1.0.7
Requires:       jboss-ejb3-proxy-impl >= 0:1.0.6
Requires:       jboss-ejb3-proxy-spi >= 0:1.0.0
Requires:       jboss-ejb3-security >= 0:1.0.2
Requires:       jboss-ejb3-timerservice-spi >= 0:1.0.0
Requires:       jboss-ejb3-transactions >= 0:1.0.2
Requires:       jboss-ejb3-timeout-spi >= 0:0.1.1
# XXX: 0:1.0.0-alpha-1
Requires:       jboss-ejb3-vfs-spi >= 0:1.0.0
Requires:       jboss-integration >= 0:5.0.3
Requires:       jboss-ejb-3.0-api
Requires:       jboss-jacc-1.1-api
Requires:       jboss-jca-1.5-api
Requires:       jboss-jms-1.1-api
Requires:       jboss-bootstrap >= 0:1.0.1
# XXX: 1.0.2-alpha-1
Requires:       jboss-jpa-deployers >= 0:1.0.0
Requires:       jboss-common-logging-spi
Requires:       jboss-metadata
Requires:       jboss-microcontainer2
Requires:       jboss-naming
# XXX: 2.0.4.SP3
Requires:       jboss-security-spi >= 1:2.0.4
Requires:       jbosssx2
Requires:       jbossws-spi
# XXX: 1.6.0
Requires:       quartz
# sun-jaxws:jaxws-api
Requires:       glassfish-jaxws >= 0:2.1.3
# sun-jaxws:jsr181-api
Requires:       glassfish-jaxws >= 0:2.1.3
Requires:       gnu-trove
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  jpackage-utils
BuildRequires:  maven2
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-enforcer
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-rar
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-jboss-deploy-plugin >= 0:1.6
BuildRequires:  maven2-plugin-release
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:	codehaus-stax-api
BuildRequires:  javassist >= 0:3.7.1
BuildRequires:  glassfish-javamail >= 0:1.4
BuildRequires:  sun-saaj-1.3-api >= 0:1.3
BuildRequires:  jbossts >= 1:4.3.0
BuildRequires:  junit4
BuildRequires:  hibernate3-annotations
BuildRequires:  hibernate3
BuildRequires:  hibernate3-entitymanager
BuildRequires:  jboss-aop2
# XXX: 1.0.0.Beta1
BuildRequires:  jboss-aspects-test >= 0:1.0.0
BuildRequires:  jboss-remoting-aspects
BuildRequires:  jboss-cache-core >= 0:3.1.0
BuildRequires:  jboss-cluster-ha-client >= 0:1.1.1
BuildRequires:  jboss-cluster-ha-server-api >= 0:1.1.1
BuildRequires:  jboss-deployers
BuildRequires:  jboss-ejb3-build >= 0:1.0.13
BuildRequires:  jboss-ejb3-context-base >= 0:0.1.1
BuildRequires:  jboss-ejb3-context-naming >= 0:0.1.1
BuildRequires:  jboss-ejb3-cache >= 0:1.0.0
BuildRequires:  jboss-ejb3-common >= 0:1.0.1
BuildRequires:  jboss-ejb3-endpoint >= 0:0.1.0
# XXX: 1.1.1
BuildRequires:  jboss-ejb3-ext-api >= 0:1.0.0
# XXX: 1.1.1
BuildRequires:  jboss-ejb3-ext-api-impl >= 0:1.0.0
BuildRequires:  jboss-ejb3-interceptors >= 0:1.0.6
BuildRequires:  jboss-ejb3-jpa-int
BuildRequires:  jboss-ejb3-metadata >= 0:1.0.0
BuildRequires:  jboss-ejb3-proxy-clustered >= 0:1.0.3
# XXX: 1.0.7
BuildRequires:  jboss-ejb3-proxy-impl >= 0:1.0.6
BuildRequires:  jboss-ejb3-proxy-spi >= 0:1.0.0
BuildRequires:  jboss-ejb3-security >= 0:1.0.2
BuildRequires:  jboss-ejb3-test >= 0:1.0.0
BuildRequires:  jboss-ejb3-timerservice-spi >= 0:1.0.0
BuildRequires:  jboss-ejb3-transactions >= 0:1.0.2
BuildRequires:  jboss-ejb3-timeout-3.0-api >= 0:0.1.1
BuildRequires:  jboss-ejb3-timeout-spi >= 0:0.1.1
# XXX: 1.0.0-alpha-1
BuildRequires:  jboss-ejb3-vfs-build >= 0:1.0.0
# XXX: 0:1.0.0-alpha-1
BuildRequires:  jboss-ejb3-vfs-spi >= 0:1.0.0
BuildRequires:  jboss-integration >= 0:5.0.3
BuildRequires:  jboss-ejb-3.0-api
BuildRequires:  jboss-jacc-1.1-api
BuildRequires:  jboss-jca-1.5-api
BuildRequires:  jboss-jms-1.1-api
BuildRequires:  jbossweb-servlet-2.5-api
BuildRequires:  jboss-bootstrap >= 0:1.0.1
# XXX: 1.0.2-alpha-1
BuildRequires:  jboss-jpa-deployers >= 0:1.0.0
BuildRequires:  jboss-common-logging-spi
BuildRequires:  jboss-metadata
BuildRequires:  jboss-microcontainer2
BuildRequires:  jboss-naming
# XXX: 2.0.4.SP3
BuildRequires:  jboss-security-spi >= 1:2.0.4
BuildRequires:  jbosssx2
BuildRequires:  jboss-test
BuildRequires:  jbossws-spi
BuildRequires:  mockito >= 0:1.8.4
# XXX: 1.6.0
BuildRequires:  quartz
# sun-jaxws:jaxws-api
BuildRequires:  glassfish-jaxws >= 0:2.1.3
# sun-jaxws:jsr181-api
BuildRequires:  glassfish-jaxws >= 0:2.1.3
BuildRequires:  gnu-trove
# FIXME: for hibernate3
BuildRequires:  hsqldb
# FIXME: for hibernate3, but does not provide jta_1_1_api
BuildRequires:  jboss-transaction-1.0.1-api
# FIXME: for org.jboss.jbossas:jboss-as-main:jar:5.1.0.GA
BuildRequires:  jboss-logbridge >= 0:1.0.0
# FIXME: for org.jboss.jbossas:jboss-as-deployment:jar:5.1.0.GA
BuildRequires:  jboss-jad-1.2-api >= 0:5.0.1
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
JBoss EJB core.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires:       jpackage-utils

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q 
%patch0 -p1 -b .sav0
%patch1 -p1 -b .sav1

%{__cp} -p %{SOURCE2} maven2-settings.xml

%{__sed} -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file:`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
%{__sed} -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file:`pwd`/external_repo</url>|g" maven2-settings.xml
%{__sed} -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file:`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
%{__sed} -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:%{_datadir}/maven2/plugins</url>|g" maven2-settings.xml
%{__sed} -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:%{_datadir}/eclipse/plugins</url>|g" maven2-settings.xml

%{__mkdir} external_repo
%{__ln_s} %{_javadir} external_repo/JPP

%build
export LANG=en_US.UTF-8
export M2SETTINGS=`pwd`/maven2-settings.xml
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository
%{__mkdir_p} ${MAVEN_REPO_LOCAL}/javax/security/jaas/1.0.01/
%{__ln_s} %{_jvmdir}/java/jre/lib/rt.jar $MAVEN_REPO_LOCAL/javax/security/jaas/1.0.01/jaas-1.0.01.jar
%{_bindir}/mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -Dmaven.test.skip=true \
        -DaltDeploymentRepository=jboss-releases::default::file:`pwd`/maven2-brew \
        -Djboss.repository.root=jboss-releases::default::file:`pwd`/maven2-brew \
        javadoc:javadoc javadoc:jar deploy

%install
%{__rm} -rf %{buildroot}

# jars
%{__mkdir_p} %{buildroot}%{_javadir}
%{__cp} -p target/jboss-ejb3-core.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}.jar
%{__cp} -p target/jboss-ejb3-core-client.jar %{buildroot}%{_javadir}/%{name}-client-%{namedversion}.jar
%{__cp} -p target/jboss-ejb3-core-javadoc.jar %{buildroot}%{_javadir}/%{name}-javadoc-%{namedversion}.jar
%{__cp} -p target/jboss-ejb3-core-sources.jar %{buildroot}%{_javadir}/%{name}-sources-%{namedversion}.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} "s|-%{namedversion}||g"`; done)

# pom
%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms
%{__cp} -p pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom
%add_to_maven_depmap org.jboss.ejb3 jboss-ejb3-core %{namedversion} JPP %{name}

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__cp} -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__ln_s} %{name}-%{namedversion} %{buildroot}%{_javadocdir}/%{name}

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com
%{__cp} -pr maven2-brew %{buildroot}%{_javadir}/repository.jboss.com
%{__mkdir_p} %{buildroot}%{repodir}
%{__mkdir_p} %{buildroot}%{repodirlib}
%{__cp} -p %{SOURCE3} %{buildroot}%{repodir}/component-info.xml
tag=`/bin/echo %{namedversion}-brew`
%{__sed} -i "s/@VERSION@/$tag/g" %{buildroot}%{repodir}/component-info.xml
tag=`/bin/echo %{name}-%{version}-%{release} | %{__sed} 's|\.|_|g'`
%{__sed} -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
%{__mkdir_p} %{buildroot}%{repodirsrc}
%{__cp} -p %{PATCH0} %{buildroot}%{repodirsrc}
%{__cp} -p %{PATCH1} %{buildroot}%{repodirsrc}
%{__cp} -p %{SOURCE0} %{buildroot}%{repodirsrc}
%{__cp} -p %{SOURCE1} %{buildroot}%{repodirsrc}
%{__cp} -p %{SOURCE2} %{buildroot}%{repodirsrc}
%{__cp} -p %{buildroot}%{_javadir}/%{name}-%{namedversion}.jar %{buildroot}%{repodirlib}/jboss-ejb3-core.jar
%{__cp} -p %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom %{buildroot}%{repodirlib}/jboss-ejb3-core.pom
%{__cp} -p %{buildroot}%{_javadir}/%{name}-client-%{namedversion}.jar %{buildroot}%{repodirlib}/jboss-ejb3-core-client.jar
%{__cp} -p %{buildroot}%{_javadir}/%{name}-javadoc-%{namedversion}.jar %{buildroot}%{repodirlib}/jboss-ejb3-core-javadoc.jar
%{__cp} -p %{buildroot}%{_javadir}/%{name}-sources-%{namedversion}.jar %{buildroot}%{repodirlib}/jboss-ejb3-core-sources.jar
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}-%{namedversion}.jar
%{_javadir}*/%{name}.jar
%{_javadir}*/%{name}-client-%{namedversion}.jar
%{_javadir}*/%{name}-client.jar
%{_javadir}*/%{name}-javadoc-%{namedversion}.jar
%{_javadir}*/%{name}-javadoc.jar
%{_javadir}*/%{name}-sources-%{namedversion}.jar
%{_javadir}*/%{name}-sources.jar
%{_datadir}/maven2/poms/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Fri Aug 19 2011 Martha Benitez <mbenitez@redhat.com> - 0:1.3.8-0.1
- Upgrade to 1.3.8

* Thu Mar 24 2011 David Walluck <dwalluck@redhat.com> 0:1.3.7-0.3
- patch POM versions

* Thu Mar 10 2011 David Walluck <dwalluck@redhat.com> 0:1.3.7-0.2
- update org.jboss.integration:jboss-jca-spi version

* Wed Feb 16 2011 David Walluck <dwalluck@redhat.com> 0:1.3.7-0.1
- 1.3.7
- use jbossweb-servlet-2.5-api (runtime-optional)
- produce and deploy javadoc:jar
- Requires: jpackage-utils
- fix repolib dir ownership
- use maven2-plugin-release, not maven-release-plugin
- remove incorrect BuildRequires
- remove BuildRequires: jboss-security-aspects
- remove BuildRequires: jakarta-commons-codec
- remove BuildRequires: qdox

* Tue Jan 18 2011 Martha Benitez <mbenitez@redhat.com> - 0:1.3.6-0.3
- Rebuild for MEAD
- Add BR qdox

* Tue Nov 16 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.3.6-0.2
- Build with maven 2.2.1
- Change BR maven-release to maven-release-plugin
- Add BR codehaus-stax-api, jakarta-commons-codec jboss-security-aspects

* Thu Aug 19 2010 David Walluck <dwalluck@redhat.com> 0:1.3.6-0.1
- 1.3.6

* Wed Aug 18 2010 David Walluck <dwalluck@redhat.com> 0:1.3.5-0.2
- pull again from tag
- set LANG

* Tue Aug 17 2010 David Walluck <dwalluck@redhat.com> 0:1.3.5-0.1
- 1.3.5
- don't comment out all javadoc options in pom, just apiviz

* Tue Jun 22 2010 David Walluck <dwalluck@redhat.com> 0:1.3.2-0.4
- update (Build)Requires and jpp-depmap

* Thu Jun 03 2010 David Walluck <dwalluck@redhat.com> 0:1.3.2-0.3
- update pom to use jboss-bootstrap

* Wed Jun 02 2010 David Walluck <dwalluck@redhat.com> 0:1.3.2-0.1
- 1.3.2
- fix depmap entry
- fix repolib

* Thu May 06 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.1.22-3.1.1
- rebuilt

* Thu Apr 08 2010 Hui Wang <huwang@redhat.com> 0:1.1.22-3.1
- Rebuild

* Fri Mar 05 2010 Martha Benitez <mbenitez@redhat.com> 0:1.1.22-3
- Comment (B)R gjt-jpl-*
- Add BR jboss-transaction-1.0.1-api

* Tue Mar 02 2010 Martha Benitez <mbenitez@redhat.com> 0:1.1.22-2
- Change (B)R quartz16 to quartz
- Change (B)R geronimo-ws-metadata-2.0-api to sun-ws-metadata-2.0-api
- Add BR hsqldb, jboss-profiler
- Bundle jboss-system jar

* Thu Dec 03 2009 Martha Benitez <mbenitez@redhat.com> 0:1.1.22-1
- Upgrade to 1.1.22
- Remove jboss-parent.pom as source, add BR instead
- Add (B)R jboss-ejb3-jpa-int

* Thu Nov 12 2009 Martha Benitez <mbenitez@redhat.com> 0:1.1.18-2
- Add client.jar, sources.jar and javadoc.jar to repolib

* Mon Sep 21 2009 Martha Benitez <mbenitez@redhat.com> - 0:1.1.18-1
- Upgrade to 1.1.18
- Comment patches 1 and 2

* Thu Sep 17 2009 Yong Yang <yyang@redhat.com> - 0:1.1.17-1.3
- Install PATCH2 PATCH3 to -repolib

* Thu Sep 17 2009 Yong Yang <yyang@redhat.com> - 0:1.1.17-1.2
- Add -repolib

* Tue Sep 15 2009 Yong Yang <yyang@redhat.com> - 0:1.1.17-1.1
- Upgrade to 1.1.17
- Comment "Patch1: jboss-ejb3-core-EjbLinkDemandMetaData.patch", 1.1.17 has included this patch

* Thu Sep 3 2009 Yong Yang <yyang@redhat.com> - 0:1.1.6-2.1
- Import from jpackage
- Change BR maven-shared-enforcer-rule-api to maven-enforcer-rule-api
- BR jbossws, jbossts, geronimo-ws-metadata-2.0-api, objectweb-asm
- Add jpp depmap for jboss-parent, jbossws, jsr173_api, jbossts, objectweb-asm, jpl-util, jpl-pattern
- Correct javax/security/jaas/1.0.01/jaas-1.0.01.jar link
- Add pom.xml patch

* Sat Aug 15 2009 Ralph Apel <r.apel@r-apel.de> - 0:1.1.6-2
- Omit bad -build pom

* Sat Aug 15 2009 Ralph Apel <r.apel@r-apel.de> - 0:1.1.6-1
- first release
